## clang 3.0

=== tools/clang/Makefile ===
##===- Makefile --------------------------------------------*- Makefile -*-===##
#
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
#
##===----------------------------------------------------------------------===##

# If CLANG_LEVEL is not set, then we are the top-level Makefile. Otherwise, we
# are being included from a subdirectory makefile.

ifndef CLANG_LEVEL

IS_TOP_LEVEL := 1
CLANG_LEVEL := .
DIRS := utils/TableGen include lib tools runtime docs unittests

PARALLEL_DIRS :=

ifeq ($(BUILD_EXAMPLES),1)
  PARALLEL_DIRS += examples
endif
endif

ifeq ($(MAKECMDGOALS),libs-only)
  DIRS := $(filter-out tools docs, $(DIRS))
  OPTIONAL_DIRS :=
endif

###
# Common Makefile code, shared by all Clang Makefiles.

# Set LLVM source root level.
LEVEL := $(CLANG_LEVEL)/../..

# Include LLVM common makefile.
include $(LEVEL)/Makefile.common

ifneq ($(ENABLE_DOCS),1)
  DIRS := $(filter-out docs, $(DIRS))
endif

# Set common Clang build flags.
CPP.Flags += -I$(PROJ_SRC_DIR)/$(CLANG_LEVEL)/include -I$(PROJ_OBJ_DIR)/$(CLANG_LEVEL)/include
ifdef CLANG_VENDOR
CPP.Flags += -DCLANG_VENDOR='"$(CLANG_VENDOR) "'
endif
ifdef CLANG_REPOSITORY_STRING
CPP.Flags += -DCLANG_REPOSITORY_STRING='"$(CLANG_REPOSITORY_STRING)"'
endif

# Disable -fstrict-aliasing. Darwin disables it by default (and LLVM doesn't
# work with it enabled with GCC), Clang/llvm-gcc don't support it yet, and newer
# GCC's have false positive warnings with it on Linux (which prove a pain to
# fix). For example:
#   http://gcc.gnu.org/PR41874
#   http://gcc.gnu.org/PR41838
#
# We can revisit this when LLVM/Clang support it.
CXX.Flags += -fno-strict-aliasing

# Set up Clang's tblgen.
ifndef CLANG_TBLGEN
  ifeq ($(LLVM_CROSS_COMPILING),1)
    CLANG_TBLGEN := $(BuildLLVMToolDir)/clang-tblgen$(BUILD_EXEEXT)
  else
    CLANG_TBLGEN := $(LLVMToolDir)/clang-tblgen$(EXEEXT)
  endif
endif
ClangTableGen = $(CLANG_TBLGEN) $(TableGen.Flags)

###
# Clang Top Level specific stuff.

ifeq ($(IS_TOP_LEVEL),1)

ifneq ($(PROJ_SRC_ROOT),$(PROJ_OBJ_ROOT))
$(RecursiveTargets)::
	$(Verb) for dir in test unittests; do \
	  if [ -f $(PROJ_SRC_DIR)/$${dir}/Makefile ] && [ ! -f $${dir}/Makefile ]; then \
	    $(MKDIR) $${dir}; \
	    $(CP) $(PROJ_SRC_DIR)/$${dir}/Makefile $${dir}/Makefile; \
	  fi \
	done
endif

test::
	@ $(MAKE) -C test

report::
	@ $(MAKE) -C test report

clean::
	@ $(MAKE) -C test clean

libs-only: all

tags::
	$(Verb) etags `find . -type f -name '*.h' -or -name '*.cpp' | \
	  grep -v /lib/Headers | grep -v /test/`

cscope.files:
	find tools lib include -name '*.cpp' \
	                    -or -name '*.def' \
	                    -or -name '*.td' \
	                    -or -name '*.h' > cscope.files

.PHONY: test report clean cscope.files

endif

=== tools/clang/docs/Makefile ===
##===- docs/Makefile ---------------------------------------*- Makefile -*-===##
# 
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
# 
##===----------------------------------------------------------------------===##

CLANG_LEVEL := ..
DIRS       := tools

ifdef BUILD_FOR_WEBSITE
PROJ_OBJ_DIR = .
DOXYGEN = doxygen

$(PROJ_OBJ_DIR)/doxygen.cfg: doxygen.cfg.in
	cat $< | sed \
	  -e 's/@abs_srcdir@/./g' \
	  -e 's/@DOT@/dot/g' \
	  -e 's/@PACKAGE_VERSION@/mainline/' \
	  -e 's/@abs_builddir@/./g' > $@
endif

include $(CLANG_LEVEL)/Makefile

HTML       := $(wildcard $(PROJ_SRC_DIR)/*.html) \
              $(wildcard $(PROJ_SRC_DIR)/*.css)
#IMAGES     := $(wildcard $(PROJ_SRC_DIR)/img/*.*)
DOXYFILES  := doxygen.cfg.in doxygen.css doxygen.footer doxygen.header \
              doxygen.intro
EXTRA_DIST := $(HTML) $(DOXYFILES) llvm.css CommandGuide img

.PHONY: install-html install-doxygen doxygen generated

install_targets :=
ifndef ONLY_MAN_DOCS
install_targets += install-html
endif
ifeq ($(ENABLE_DOXYGEN),1)
install_targets += install-doxygen
endif
install-local:: $(install_targets)

# Live documentation is generated for the web site using this target:
# 'make generated BUILD_FOR_WEBSITE=1'
generated:: doxygen

install-html: $(PROJ_OBJ_DIR)/html.tar.gz
	$(Echo) Installing HTML documentation
	$(Verb) $(MKDIR) $(DESTDIR)$(PROJ_docsdir)/html
	$(Verb) $(MKDIR) $(DESTDIR)$(PROJ_docsdir)/html/img
	$(Verb) $(DataInstall) $(HTML) $(DESTDIR)$(PROJ_docsdir)/html
#	$(Verb) $(DataInstall) $(IMAGES) $(DESTDIR)$(PROJ_docsdir)/html/img
	$(Verb) $(DataInstall) $(PROJ_OBJ_DIR)/html.tar.gz $(DESTDIR)$(PROJ_docsdir)

$(PROJ_OBJ_DIR)/html.tar.gz: $(HTML)
	$(Echo) Packaging HTML documentation
	$(Verb) $(RM) -rf $@ $(PROJ_OBJ_DIR)/html.tar
	$(Verb) cd $(PROJ_SRC_DIR) && \
	  $(TAR) cf $(PROJ_OBJ_DIR)/html.tar *.html
	$(Verb) $(GZIPBIN) $(PROJ_OBJ_DIR)/html.tar

install-doxygen: doxygen
	$(Echo) Installing doxygen documentation
	$(Verb) $(MKDIR) $(DESTDIR)$(PROJ_docsdir)/html/doxygen
	$(Verb) $(DataInstall) $(PROJ_OBJ_DIR)/doxygen.tar.gz $(DESTDIR)$(PROJ_docsdir)
	$(Verb) cd $(PROJ_OBJ_DIR)/doxygen && \
	  $(FIND) . -type f -exec \
	    $(DataInstall) {} $(DESTDIR)$(PROJ_docsdir)/html/doxygen \;

doxygen: regendoc $(PROJ_OBJ_DIR)/doxygen.tar.gz

regendoc:
	$(Echo) Building doxygen documentation
	$(Verb) if test -e $(PROJ_OBJ_DIR)/doxygen ; then \
	  $(RM) -rf $(PROJ_OBJ_DIR)/doxygen ; \
	fi
	$(Verb) $(DOXYGEN) $(PROJ_OBJ_DIR)/doxygen.cfg

$(PROJ_OBJ_DIR)/doxygen.tar.gz: $(DOXYFILES) $(PROJ_OBJ_DIR)/doxygen.cfg
	$(Echo) Packaging doxygen documentation
	$(Verb) $(RM) -rf $@ $(PROJ_OBJ_DIR)/doxygen.tar
	$(Verb) $(TAR) cf $(PROJ_OBJ_DIR)/doxygen.tar doxygen
	$(Verb) $(GZIPBIN) $(PROJ_OBJ_DIR)/doxygen.tar
	$(Verb) $(CP) $(PROJ_OBJ_DIR)/doxygen.tar.gz $(PROJ_OBJ_DIR)/doxygen/html/

userloc: $(LLVM_SRC_ROOT)/docs/userloc.html

$(LLVM_SRC_ROOT)/docs/userloc.html:
	$(Echo) Making User LOC Table
	$(Verb) cd $(LLVM_SRC_ROOT) ; ./utils/userloc.pl -details -recurse \
	  -html lib include tools runtime utils examples autoconf test > docs/userloc.html

uninstall-local::
	$(Echo) Uninstalling Documentation
	$(Verb) $(RM) -rf $(DESTDIR)$(PROJ_docsdir)

=== tools/clang/runtime/CMakeLists.txt ===
# TODO: Set the install directory.

set(known_subdirs
  "compiler-rt"
  "libcxx"
  )

foreach (dir ${known_subdirs})
  if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${dir}/CMakeLists.txt)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/${dir})
  endif()
endforeach()

=== tools/clang/examples/clang-interpreter/CMakeLists.txt ===
set(LLVM_USED_LIBS
    clangFrontend
    clangSerialization
    clangDriver
    clangCodeGen
    clangSema
    clangStaticAnalyzerFrontend
    clangStaticAnalyzerCheckers
    clangStaticAnalyzerCore
    clangIndex
    clangAnalysis
    clangRewrite
    clangAST
    clangParse
    clangLex
    clangBasic
    )

set(LLVM_LINK_COMPONENTS
    jit
    interpreter
    nativecodegen
    asmparser
    bitreader
    bitwriter
    codegen
    ipo
    selectiondag
  )

add_clang_executable(clang-interpreter
  main.cpp
  )
add_dependencies(clang-interpreter clang-headers)

=== tools/clang/lib/Basic/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS mc)

add_clang_library(clangBasic
  Builtins.cpp
  ConvertUTF.c
  Diagnostic.cpp
  DiagnosticIDs.cpp
  FileManager.cpp
  FileSystemStatCache.cpp
  IdentifierTable.cpp
  LangOptions.cpp
  SourceLocation.cpp
  SourceManager.cpp
  TargetInfo.cpp
  Targets.cpp
  TokenKinds.cpp
  Version.cpp
  VersionTuple.cpp
  )

# Determine Subversion revision.
# FIXME: This only gets updated when CMake is run, so this revision number
# may be out-of-date!
if( NOT IS_SYMLINK "${CLANG_SOURCE_DIR}" )  # See PR 8437
  find_package(Subversion)
endif()
if (Subversion_FOUND AND EXISTS "${CLANG_SOURCE_DIR}/.svn")
  Subversion_WC_INFO(${CLANG_SOURCE_DIR} CLANG)
  set_source_files_properties(Version.cpp
    PROPERTIES COMPILE_DEFINITIONS "SVN_REVISION=\"${CLANG_WC_REVISION}\"")
endif()

add_dependencies(clangBasic 
                 ClangARMNeon
                 ClangAttrList
                 ClangDiagnosticAnalysis
                 ClangDiagnosticAST
                 ClangDiagnosticCommon
                 ClangDiagnosticDriver
                 ClangDiagnosticFrontend
                 ClangDiagnosticGroups
                 ClangDiagnosticLex
                 ClangDiagnosticParse
                 ClangDiagnosticSema
                 ClangDiagnosticIndexName)

=== tools/clang/lib/Serialization/CMakeLists.txt ===
# TODO: This must need some dependencies, but it builds fine without them.
#set(LLVM_USED_LIBS ???)

add_clang_library(clangSerialization
  ASTCommon.h
  ASTReaderInternals.h
  ASTCommon.cpp
  ASTReader.cpp
  ASTReaderDecl.cpp
  ASTReaderStmt.cpp
  ASTWriter.cpp
  ASTWriterDecl.cpp
  ASTWriterStmt.cpp
  ChainedIncludesSource.cpp
  GeneratePCH.cpp
  Module.cpp
  ModuleManager.cpp
  )

add_dependencies(clangSerialization
  ClangAttrClasses
  ClangAttrList
  ClangAttrPCHRead
  ClangAttrPCHWrite
  ClangDiagnosticFrontend
  ClangDiagnosticLex
  ClangDiagnosticSema
  ClangDeclNodes
  ClangStmtNodes)

=== tools/clang/tools/c-index-test/Makefile ===
##===- tools/index-test/Makefile ---------------------------*- Makefile -*-===##
# 
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
# 
##===----------------------------------------------------------------------===##
CLANG_LEVEL := ../..

TOOLNAME = c-index-test

# No plugins, optimize startup time.
TOOL_NO_EXPORTS = 1

LINK_COMPONENTS := support mc
USEDLIBS = clang.a clangIndex.a clangFrontend.a clangDriver.a \
	   clangSerialization.a clangParse.a clangSema.a \
	   clangAnalysis.a clangAST.a clangLex.a clangBasic.a

include $(CLANG_LEVEL)/Makefile

=== debian/changelog ===
clang (3.0-6ubuntu3) precise; urgency=low

  * debian/patches/26-armv7-not-neon.patch: adds a d16 FPU target,
    and makes sure that none of the non-NEON FPU options enable
    NEON by default, as well as stopping the broken assumption that
    all armv7/cortex cores support NEON, as they really don't.
  * debian/patches/27-armhf-is-armv7.patch: Make armhf builds
    default to cortex-a8 with vfpv3-d16, to agree with glibc/gcc.
  * 28-powerpc-no-altivec.patch: Don't enable altivec on powerpc by
    default, as not all powerpc-compatible CPUs support altivec.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 24 Apr 2012 03:23:07 -0600

clang (3.0-6ubuntu2) precise; urgency=low

  * debian/patches/25-armhf-linker-name.diff: update armhf linker
    path to the recently agreed-upon /lib/ld-linux-armhf.so.3

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 15 Apr 2012 04:12:53 -0600

clang (3.0-6ubuntu1) precise; urgency=low

  * Merge with Debian (LP: #903509); remaining changes:
    - Set Ubuntu as vendor name instead of Debian.
    - Make the `precise' code name known.
    - Update linker flags for `precise'.
    - Set dynamic linker name for armhf, recognize arm-linux-gnueabihf triplet.
    - Remove auto-generated debian_path.h.
  * debian/patches/23-ubuntu-name.diff: Assume unknown Ubuntu releases
    behave like precise, until we know otherwise.

 -- Anders Kaseorg <andersk@mit.edu>  Fri, 02 Mar 2012 02:14:00 -0500

clang (3.0-6) unstable; urgency=low

  * Improve the soname patch
  * Drop the conflict on ocaml-nox
  * Fix the wrong path detection under armel/armhf
    (Closes: #655432)
  * sse4a / amdfam10 support where not available.
    Thanks to Aaron Haviland for the patch
    (LP: #930494)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 25 Feb 2012 13:23:29 +0100

clang (3.0-5) unstable; urgency=low

  * Fix an issue with a file override when installing libclang-common-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 21 Dec 2011 09:09:58 +0100

clang (3.0-4) unstable; urgency=low

  * Get ride of old option --experimental-checks from the manpage
    (Closes: #652047)
  * Make clang work under powerpc. Thanks to Michel Dänzer for the patch
    (Closes: #652096)
  * Introduce package libclang-common-dev which contains specific clang headers
    which are not (only) target for plugin/extension development.
    Thanks to Gabriel Corona for the help and suggestions (Closes: #652278)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Dec 2011 15:41:35 +0100

clang (3.0-3ubuntu1) precise; urgency=low

  * Merge with Debian; remaining changes:
    - Set Ubuntu as vendor name instead of Debian.
  * Make the `precise' code name known.
  * Update linker flags for `precise'.
  * Set dynamic linker name for armhf, recognize arm-linux-gnueabihf triplet.
  * Remove auto-generated debian_path.h.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Dec 2011 08:52:00 +0100

clang (3.0-3) unstable; urgency=low

  * 23-strlcpy_strlcat_warning_removed.diff: strlcat and strlcpy does not exist
    in Debian (Closes: #651454)
  * 21-searchPathHeaders.diff: Update to include also the path to clang headers
    (Closes: #645731)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 10 Dec 2011 19:24:38 +0100

clang (3.0-2) unstable; urgency=low

  * 21-searchPathHeaders.diff: Update the search path list under x86
    (Closes: #643959)
  * 22-debian-name.diff: Detection of Debian failed (Closes: #651301)
  * debian/control.in/source, debian/control, debian/rules.d/vars.mk:
    Force the minimal version on llvm-3.0-source to 3.0-3 (previous versions
    did not include patches). (Closes: #645546)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 07 Dec 2011 16:28:16 +0100

clang (3.0-1) unstable; urgency=low

  * New upstream release
  * Patches work from debian/patches:
    - 10-handleWheezySid.patch: Removed
    - 11-searchMultiArchLibDir.patch: Removed
    - 13-search-path-dpkg-based.patch: Removed
    - 15-searchPaths.patch: Removed
    - 16-backport-4.6-compta.patch: Removed
    - 17-decltype.patch: Removed
    - 14-linkerflag.patch: Refresh
    - 18-soname.patch: Refresh
    - 19-clang_debian_version.patch: Refresh
    - 20-vendor.patch: Refresh
    - 21-searchPathHeaders.diff: Updated (new search path)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 10 Nov 2011 19:49:09 +0100

clang (2.9-16) unstable; urgency=low

  * Fix one more path issues under i386 ... (Closes: #643959)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 13 Oct 2011 13:31:16 +0200

clang (2.9-15) unstable; urgency=low

  * Refactoring of some patches
  * Get ride of some gcc 4.5 paths
  * Update the configure arg from 4.5 to 4.6 (Closes: #644975, #640289)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 11 Oct 2011 23:32:19 +0200

clang (2.9-14) unstable; urgency=low

  * Rename libclang0 => libclang1
  * Depends between libclang-dev => libclang1 added 
    Move libclang.so to libclang-dev (Closes: #643940)
  * Fix some build issues
  * Add /usr/lib/gcc/i486-linux-gnu/X.Y/include/stddef.h to the search
    path for header (Closes: #643959)
  * clang can now also build Objective C code (problems with header paths)
  * Missing headers added in /usr/include/clang/ & /usr/include/clang-c/

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 03 Oct 2011 17:17:03 +0200

=== debian/control ===
Source: clang
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Arthur Loiret <aloiret@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 6.0.0), flex, bison, dejagnu, tcl8.5, expect,
    autoconf, automake1.9, perl, libtool, doxygen, chrpath, texinfo,
    sharutils, autotools-dev (>= 20060702.1), libffi-dev (>= 3.0.9),
    lsb-release, patchutils, diffstat, xz-utils, llvm-3.0-dev (>= 3.0), llvm-3.0-source (>= 3.0)
Build-Conflicts: oprofile, ocaml, ocaml-nox
Standards-Version: 3.9.2
Homepage: http://www.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/clang/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/clang/trunk/


Package: clang
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libstdc++6-4.6-dev,
 libclang-common-dev
Recommends: llvm-3.0-dev, python
Description: Low-Level Virtual Machine (LLVM), C language family frontend
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs. LLVM
 uses a single, language-independent virtual instruction set both
 as an offline code representation (to communicate code between
 compiler phases and to run-time systems) and as the compiler internal
 representation (to analyze and transform programs). This persistent
 code representation allows a common set of sophisticated compiler
 techniques to be applied at compile-time, link-time, install-time,
 run-time, or "idle-time" (between program runs).
 .
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Some of its goals include the following:
 .
 End-User Features:
 .
    * Fast compiles and low memory use
    * Expressive diagnostics (examples)
    * GCC compatibility
 .
 Utility and Applications:
 .
    * Modular library based architecture
    * Support diverse clients (refactoring, static analysis, code
      generation, etc)
    * Allow tight integration with IDEs
    * Use the LLVM 'BSD' License
 .
 Internal Design and Implementation:
 .
    * A real-world, production quality compiler
    * A simple and hackable code base
    * A single unified parser for C, Objective C, C++, and Objective C++
    * Conformance with C/C++/ObjC and their variants

Package: libclang1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libstdc++6-4.6-dev
Description: clang library
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs. LLVM
 uses a single, language-independent virtual instruction set both
 as an offline code representation (to communicate code between
 compiler phases and to run-time systems) and as the compiler internal
 representation (to analyze and transform programs). This persistent
 code representation allows a common set of sophisticated compiler
 techniques to be applied at compile-time, link-time, install-time,
 run-time, or "idle-time" (between program runs).
 .
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Some of its goals include the following:
 .
 End-User Features:
 .
    * Fast compiles and low memory use
    * Expressive diagnostics (examples)
    * GCC compatibility
 .
 Utility and Applications:
 .
    * Modular library based architecture
    * Support diverse clients (refactoring, static analysis, code
      generation, etc)
    * Allow tight integration with IDEs
    * Use the LLVM 'BSD' License
 .
 Internal Design and Implementation:
 .
    * A real-world, production quality compiler
    * A simple and hackable code base
    * A single unified parser for C, Objective C, C++, and Objective C++
    * Conformance with C/C++/ObjC and their variants
 .
 This package contains the clang library.

Package: libclang-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libstdc++6-4.6-dev,
 libclang1 (= ${binary:Version}), libclang-common-dev
Description: clang library - Development package
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs. LLVM
 uses a single, language-independent virtual instruction set both
 as an offline code representation (to communicate code between
 compiler phases and to run-time systems) and as the compiler internal
 representation (to analyze and transform programs). This persistent
 code representation allows a common set of sophisticated compiler
 techniques to be applied at compile-time, link-time, install-time,
 run-time, or "idle-time" (between program runs).
 .
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Some of its goals include the following:
 .
 End-User Features:
 .
    * Fast compiles and low memory use
    * Expressive diagnostics (examples)
    * GCC compatibility
 .
 Utility and Applications:
 .
    * Modular library based architecture
    * Support diverse clients (refactoring, static analysis, code
      generation, etc)
    * Allow tight integration with IDEs
    * Use the LLVM 'BSD' License
 .
 Internal Design and Implementation:
 .
    * A real-world, production quality compiler
    * A simple and hackable code base
    * A single unified parser for C, Objective C, C++, and Objective C++
    * Conformance with C/C++/ObjC and their variants
 .
 This package contains the clang headers to develop extensions over libclang.

Package: libclang-common-dev
Architecture: any
Replaces: libclang-dev
Section: libdevel
Description: clang library - Common development package
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs. LLVM
 uses a single, language-independent virtual instruction set both
 as an offline code representation (to communicate code between
 compiler phases and to run-time systems) and as the compiler internal
 representation (to analyze and transform programs). This persistent
 code representation allows a common set of sophisticated compiler
 techniques to be applied at compile-time, link-time, install-time,
 run-time, or "idle-time" (between program runs).
 .
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Some of its goals include the following:
 .
 End-User Features:
 .
    * Fast compiles and low memory use
    * Expressive diagnostics (examples)
    * GCC compatibility
 .
 Utility and Applications:
 .
    * Modular library based architecture
    * Support diverse clients (refactoring, static analysis, code
      generation, etc)
    * Allow tight integration with IDEs
    * Use the LLVM 'BSD' License
 .
 Internal Design and Implementation:
 .
    * A real-world, production quality compiler
    * A simple and hackable code base
    * A single unified parser for C, Objective C, C++, and Objective C++
    * Conformance with C/C++/ObjC and their variants
 .
 This package contains the clang generic headers.

## clang 3.1

=== tools/clang/lib/AST/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS support)

set(LLVM_USED_LIBS clangBasic clangLex)

add_clang_library(clangAST
  APValue.cpp
  ASTConsumer.cpp
  ASTContext.cpp
  ASTDiagnostic.cpp
  ASTImporter.cpp
  AttrImpl.cpp
  CXXInheritance.cpp
  Decl.cpp
  DeclarationName.cpp
  DeclBase.cpp
  DeclCXX.cpp
  DeclFriend.cpp
  DeclGroup.cpp
  DeclObjC.cpp
  DeclPrinter.cpp
  DeclTemplate.cpp
  DumpXML.cpp
  Expr.cpp
  ExprClassification.cpp
  ExprConstant.cpp
  ExprCXX.cpp
  ExternalASTSource.cpp
  InheritViz.cpp
  ItaniumCXXABI.cpp
  ItaniumMangle.cpp
  LambdaMangleContext.cpp
  Mangle.cpp
  MicrosoftCXXABI.cpp
  MicrosoftMangle.cpp
  NestedNameSpecifier.cpp
  NSAPI.cpp
  ParentMap.cpp
  RecordLayout.cpp
  RecordLayoutBuilder.cpp
  SelectorLocationsKind.cpp
  Stmt.cpp
  StmtDumper.cpp
  StmtIterator.cpp
  StmtPrinter.cpp
  StmtProfile.cpp
  StmtViz.cpp
  TemplateBase.cpp
  TemplateName.cpp
  Type.cpp
  TypeLoc.cpp
  TypePrinter.cpp
  VTableBuilder.cpp
  VTTBuilder.cpp
  )

add_dependencies(clangAST ClangARMNeon ClangAttrClasses ClangAttrList 
                 ClangAttrImpl ClangDiagnosticAST ClangDeclNodes ClangStmtNodes)

=== tools/clang/lib/Edit/CMakeLists.txt ===
set(LLVM_USED_LIBS clangBasic clangAST clangLex)

add_clang_library(clangEdit
  Commit.cpp
  EditedSource.cpp
  RewriteObjCFoundationAPI.cpp
  )

=== tools/clang/tools/c-index-test/Makefile ===
--- 
+++ 
@@ -10,12 +10,16 @@
 
 TOOLNAME = c-index-test
 
+# If a separate install prefix was specified for internal tools, use it
+# when installing c-index-test.
+INTERNAL_TOOL = 1
+
 # No plugins, optimize startup time.
 TOOL_NO_EXPORTS = 1
 
 LINK_COMPONENTS := support mc
-USEDLIBS = clang.a clangIndex.a clangFrontend.a clangDriver.a \
+USEDLIBS = clang.a clangFrontend.a clangDriver.a \
 	   clangSerialization.a clangParse.a clangSema.a \
-	   clangAnalysis.a clangAST.a clangLex.a clangBasic.a
+	   clangAnalysis.a clangEdit.a clangAST.a clangLex.a clangBasic.a
 
 include $(CLANG_LEVEL)/Makefile

=== tools/clang/tools/libclang/Makefile ===
##===- tools/libclang/Makefile -----------------------------*- Makefile -*-===##
# 
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
# 
##===----------------------------------------------------------------------===##

CLANG_LEVEL := ../..
LIBRARYNAME = clang

EXPORTED_SYMBOL_FILE = $(PROJ_SRC_DIR)/libclang.exports

LINK_LIBS_IN_SHARED = 1
SHARED_LIBRARY = 1

LINK_COMPONENTS := support mc
USEDLIBS = clangARCMigrate.a clangRewrite.a clangFrontend.a clangDriver.a \
     clangSerialization.a \
		 clangParse.a clangSema.a clangEdit.a clangAnalysis.a \
		 clangAST.a clangLex.a clangBasic.a

include $(CLANG_LEVEL)/Makefile

# Add soname to the library.
ifeq ($(HOST_OS), $(filter $(HOST_OS), Linux FreeBSD GNU))
        LDFLAGS += -Wl,-soname,lib$(LIBRARYNAME)$(SHLIBEXT)
endif

##===----------------------------------------------------------------------===##
# FIXME: This is copied from the 'lto' makefile.  Should we share this?
##===----------------------------------------------------------------------===##

ifeq ($(HOST_OS),Darwin)
    LLVMLibsOptions += -Wl,-compatibility_version,1

    # Set dylib internal version number to submission number.
    ifdef LLVM_SUBMIT_VERSION
        LLVMLibsOptions += -Wl,-current_version \
                           -Wl,$(LLVM_SUBMIT_VERSION).$(LLVM_SUBMIT_SUBVERSION)
    endif

    # Extra options to override libtool defaults.
    LLVMLibsOptions += -Wl,-dead_strip -Wl,-seg1addr,0xE0000000 

    # Mac OS X 10.4 and earlier tools do not allow a second -install_name on command line
    DARWIN_VERS := $(shell echo $(TARGET_TRIPLE) | sed 's/.*darwin\([0-9]*\).*/\1/')
    ifneq ($(DARWIN_VERS),8)
       LLVMLibsOptions += -Wl,-install_name \
                          -Wl,"@rpath/lib$(LIBRARYNAME)$(SHLIBEXT)"
    endif
endif

=== debian/changelog ===
clang (3.1-8ubuntu2) raring; urgency=low

  * Build-depend on python.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Nov 2012 19:24:30 +0100

clang (3.1-8ubuntu1) raring; urgency=low

  * Merge with Debian; remaining changes:
    - Set Ubuntu as vendor name instead of Debian.
    - Update linker flags for `precise'.
    - debian/patches/23-ubuntu-name.diff: Assume unknown Ubuntu releases
      behave like precise, until we know otherwise.
    - debian/patches/25-armhf-linker-name.diff: set armhf linker path
      to the recently agreed-upon /lib/ld-linux-armhf.so.3,
      recognize arm-linux-gnueabihf triplet.
    - debian/patches/26-armv7-not-neon.patch: make sure that none of the
      non-NEON FPU options enable NEON by default, as well as stopping
      the broken assumption that all armv7/cortex cores support NEON,
      as they really don't.
    - debian/patches/27-armhf-is-armv7.patch: Make armhf builds
      default to cortex-a8 with vfpv3-d16, to agree with glibc/gcc.
    - 28-powerpc-no-altivec.patch: Don't enable altivec on powerpc by
      default, as not all powerpc-compatible CPUs support altivec.
  * Build using gcc-4.7.
  * Make the `quantal' and `raring' code names known.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Nov 2012 15:12:59 +0100

clang (3.1-8) unstable; urgency=low

  * Also ship clang static libraries for the plugin developments
    (Closes: #678638)
  * Also disable TEST(unescapeJsonCommandLine, ReturnsEmptyArrayOnEmptyString)
  
 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Jun 2012 23:03:55 +0200

clang (3.1-7) unstable; urgency=low

  * Revert previous change (disable test suite for some archs) 
    and disable instead just the failing test:
    TEST(unescapeJsonCommandLine, SplitsOnSpaces)
    (Closes: #678906)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 25 Jun 2012 12:00:06 +0200

clang (3.1-6) unstable; urgency=low

  * Disable tests for kfreebsd-amd64 kfreebsd-i386 mips mipsel because a test
    is freezing. This prevents clang to migrate to testing.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 21 Jun 2012 11:04:39 +0200

clang (3.1-5) unstable; urgency=low

  * When the configure fails, display the content of config.log
  * clang package provides clang-3.1
  * clang package provides virtual package 'c-compiler'
  * control.in/source didn't contain the dependency on gcc-4.6 (Closes: #677853)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 17 Jun 2012 12:03:52 +0200

clang (3.1-4) unstable; urgency=low

  * Force the version 4.6 of gcc to build (Closes: #675056, #674340)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 01 Jun 2012 15:06:28 +0200

clang (3.1-3) unstable; urgency=low

  * Bring back the strlcpy & strlcat patch (Closes: #651454)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 25 May 2012 09:39:24 +0200

clang (3.1-2) unstable; urgency=low

  * Add /usr/include/$(DEB_HOST_MULTIARCH) to the search path 
    with also DEB_HOST_GNU_TYPE (Closes: #671913)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 23 May 2012 23:32:40 +0200

clang (3.1-1) unstable; urgency=low

  * New upstream release
  * Upload in unstable
  * Update of the description
  * Explicit version dependency between clang => libclang-common-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 21 May 2012 13:31:32 +0200

clang (3.1~+rc1-2) experimental; urgency=low

  * 23-strlcpy_strlcat_warning_removed.diff reconnected
  * 12-gcc-4.6.patch, 22-debian-name.diff, 24-path-multiarch.diff,
    25-amdfam10.diff, 14-linkerflag.patch removed

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 23 Apr 2012 18:43:47 +0200

clang (3.1~+rc1-1) experimental; urgency=low

  * New upstream testing release
  * Drop the conflict on ocaml-nox

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 19 Apr 2012 21:04:47 +0200

clang (3.1~svn154769-1) experimental; urgency=low

  * New snapshot release
  * Fix a problem with the dependency on llvm-3.1
  * Enable tests (but do not fail the build if unexpected errors)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Apr 2012 22:28:39 +0200

clang (3.1~svn154596-1) experimental; urgency=low

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 12 Apr 2012 21:08:42 +0200

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
 Build-Depends: debhelper (>= 6.0.0), flex, bison, dejagnu, tcl8.5, expect,
     autoconf, automake1.9, perl, libtool, doxygen, chrpath, texinfo,
     sharutils, autotools-dev (>= 20060702.1), libffi-dev (>= 3.0.9),
-    lsb-release, patchutils, diffstat, xz-utils, llvm-3.0-dev (>= 3.0), llvm-3.0-source (>= 3.0)
-Build-Conflicts: oprofile, ocaml, ocaml-nox
-Standards-Version: 3.9.2
+    lsb-release, patchutils, diffstat, xz-utils, llvm-3.1-dev (>= 3.1), llvm-3.1-source (>= 3.1),
+    gcc-4.7, g++-4.7, python
+Build-Conflicts: oprofile, ocaml
+Standards-Version: 3.9.3
 Homepage: http://www.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/clang/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/clang/trunk/
@@ -19,8 +20,9 @@
 Package: clang
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstdc++6-4.6-dev,
- libclang-common-dev
-Recommends: llvm-3.0-dev, python
+ libclang-common-dev (= ${binary:Version})
+Provides: clang-3.1, c-compiler
+Recommends: llvm-3.1-dev, python
 Description: Low-Level Virtual Machine (LLVM), C language family frontend
  The Low-Level Virtual Machine (LLVM) is a collection of libraries and
  tools that make it easy to build compilers, optimizers, Just-In-Time

=== debian/rules ===
#!/usr/bin/make -f

include debian/rules.d/vars.mk

tools := clang #vmkit
include debian/packages.d/tools.mk

$(foreach build,$(builds),$(eval \
  $(build)_builddir ?= build-$(build)))
ifeq (,$(strip $(tarball)))
  srcdir	:= .
else
  ifeq (,$(strip $(srcdir)))
    $(error undefined srcdir)
  endif
endif

define pkgname
  $(shell cat $(D)/debian/control.in/$1 | awk '/^Package: / {print $$2}' | \
  sed -e 's/@UVERSION@/$(UVERSION)/;s/@GCC_VERSION@/$(gcc_version)/;s/@PKG_VERSION@/$(pkg_version)/')
endef

define buildof
  $(foreach build,$(builds),$(if $(filter $1,$($(build)_packages)),$(build),))
endef

include debian/rules.d/control.mk
include debian/rules.d/unpack.mk
include debian/rules.d/build.mk
include debian/rules.d/binary.mk

clean:
	$(RM) -r $(stampdir) $(foreach build,$(builds),$($(build)_builddir))
ifneq (,$(strip $(tarball)))
	$(RM) -r $(srcdir)
endif
	$(RM) -r $(D)/debian/ccache
	find utils -name '*.py[co]' | xargs rm -f
	rm -f tools/clang/include/clang/Debian/debian_path.h

.PHONY: clean
